# Enum Class BaitDesigner.DesignStrategy

java.lang.Object
java.lang.Enum<BaitDesigner.DesignStrategy>
picard.util.BaitDesigner.DesignStrategy

All Implemented Interfaces:
  `Serializable, Comparable<BaitDesigner.DesignStrategy>, Constable`

Enclosing class:
  `BaitDesigner`

public static enum BaitDesigner.DesignStrategy extends Enum<BaitDesigner.DesignStrategy>
Set of possible design strategies for bait design.

## Nested Class Summary

### Nested classes/interfaces inherited from class Enum

`Enum.EnumDesc<E>`

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`CenteredConstrained`
Implementation that "constrains" baits to be within the target region when possible.
`FixedOffset`
Design that places baits at fixed offsets over targets, allowing them to hang off the ends as dictated by the target size and offset.
`Simple`
Ultra simple bait design algorithm that just lays down baits starting at the target start position until either the bait start runs off the end of the target or the bait would run off the sequence

## Method Summary

Modifier and Type
Method
Description
`static BaitDesigner.DesignStrategy`
`valueOf(String name)`
Returns the enum constant of this class with the specified name.
`static BaitDesigner.DesignStrategy[]`
`values()`
Returns an array containing the constants of this enum class, in the order they are declared.

### Methods inherited from class Enum

`clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### CenteredConstrained

public static final BaitDesigner.DesignStrategy CenteredConstrained
Implementation that "constrains" baits to be within the target region when possible.

### FixedOffset

public static final BaitDesigner.DesignStrategy FixedOffset
Design that places baits at fixed offsets over targets, allowing them to hang off the ends as dictated by the target size and offset.

### Simple

public static final BaitDesigner.DesignStrategy Simple
Ultra simple bait design algorithm that just lays down baits starting at the target start position until either the bait start runs off the end of the target or the bait would run off the sequence

## Method Details

### values

public static BaitDesigner.DesignStrategy[] values()
Returns an array containing the constants of this enum class, in the order they are declared.

Returns:
  an array containing the constants of this enum class, in the order they are declared

### valueOf

public static BaitDesigner.DesignStrategy valueOf(String name)
Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum class has no constant with the specified name
  `NullPointerException` - if the argument is null